Index: trunk/LMDZ.MARS/libf/phymars/calcstormfract_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/calcstormfract_mod.F90	(revision 1974)
+++ trunk/LMDZ.MARS/libf/phymars/calcstormfract_mod.F90	(revision 1974)
@@ -0,0 +1,64 @@
+      MODULE calcstormfract_mod
+
+      IMPLICIT NONE
+
+      CONTAINS
+!=======================================================================
+! ROCKET DUST STORM - Defining dust storm fraction of the mesh
+!=======================================================================
+! before calling radiative transfer
+! SUBGRID PARAMETRIZATION 
+! -----------------------------------------------------------------------
+! Author : T. Bertrand 2014-05 
+! Institution : Laboratoire de Meteorologie Dynamique (LMD) Paris, France
+! -----------------------------------------------------------------------
+! defining the fraction of the mesh containing the rocket dust storm.
+! file using the fraction: aeropacity.F, before calling radiative transfer
+! the radiative transfer is performed in the mesh without the storm and in the mesh with the storm
+! the fraction is used to calculate the true opacity of dust within the storm
+
+      SUBROUTINE calcstormfract(ngrid,nlayer,nq,pq,totstormfract)
+                                 
+      use tracer_mod, only: igcm_stormdust_mass
+
+      implicit none
+
+!--------------------------------------------------------
+! Input Variables
+!--------------------------------------------------------
+
+      INTEGER, INTENT(IN) :: ngrid ! number of horizontal grid points
+      INTEGER, INTENT(IN) :: nlayer ! number of vertical grid points
+      INTEGER, INTENT(IN) :: nq ! number of tracer species
+      REAL, INTENT(IN) ::  pq(ngrid,nlayer,nq) ! advected field nq
+
+!--------------------------------------------------------
+! Output Variables
+!--------------------------------------------------------
+
+      REAL, INTENT(OUT) :: totstormfract(ngrid) ! fraction of the mesh containing the dust storm
+
+!--------------------------------------------------------
+! Local variables 
+!--------------------------------------------------------
+
+      REAL, PARAMETER :: mmr_ref=5.e-4 ! mass reference mixing ratio (corresponding
+                                       ! to the tau=10 reference OMEGA local dust storm)
+      REAL, PARAMETER :: fracmax=0.6    ! maximal fraction of the storm
+      REAL, PARAMETER :: fracmin=1.e-2 ! minimal fraction of the storm
+      INTEGER ig     
+ 
+! **********************************************************************
+! Definition of stormfraction
+! **********************************************************************
+
+      DO ig=1, ngrid
+       totstormfract(ig)=abs(maxval(pq(ig,2:nlayer,  & !why from 2nd layer?
+     &                     igcm_stormdust_mass)))/mmr_ref
+       totstormfract(ig)=max(totstormfract(ig),fracmin)  
+       totstormfract(ig)=min(totstormfract(ig),fracmax) 
+      ENDDO
+
+      END SUBROUTINE calcstormfract
+
+      END MODULE calcstormfract_mod
Index: trunk/LMDZ.MARS/libf/phymars/callkeys.h
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/callkeys.h	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/callkeys.h	(revision 1974)
@@ -13,13 +13,14 @@
      &   ,lifting,freedust,callddevil,scavenging,sedimentation          &
      &   ,activice,water,tifeedback,microphys,supersat,caps,photochem   &
-     &   ,calltherm,callrichsl,callslope,tituscap,callyamada4,co2clouds,&
-     &   co2useh2o,meteo_flux,CLFvaryingCO2,spantCO2,CLFvarying,        &
-     &   satindexco2
+     &   ,calltherm,callrichsl,callslope,tituscap,callyamada4,co2clouds &
+     &   ,co2useh2o,meteo_flux,CLFvaryingCO2,spantCO2,CLFvarying        &
+     &   ,satindexco2,rdstorm
      
       COMMON/callkeys_i/iradia,iaervar,iddist,ilwd,ilwb,ilwn,ncouche    &
-     &   ,dustbin,nltemodel,nircorr,solvarmod,solvaryear
+     &   ,dustbin,nltemodel,nircorr,solvarmod,solvaryear,dustinjection
      
       COMMON/callkeys_r/topdustref,semi,alphan,euveff,                  &
-     &   tke_heat_flux,dustrefir,fixed_euv_value,CLFfixval
+     &   tke_heat_flux,dustrefir,fixed_euv_value,CLFfixval,             &
+     &   coeff_injection
      
       LOGICAL callrad,calldifv,calladj,callcond,callsoil,               &
@@ -42,4 +43,5 @@
       real euveff
       real tke_heat_flux
+      real coeff_injection ! dust injection scheme coefficient
       real CLFfixval
 
@@ -53,10 +55,12 @@
       integer solvarmod   ! model for solar EUV variation
       integer solvaryear  ! mars year for realisticly varying solar EUV 
+      integer dustinjection ! dust injection scheme number 
 
       logical rayleigh
       logical tracer
       integer dustbin
-      logical freedust 
+      logical freedust  
       logical active,doubleq,submicron,lifting,callddevil,scavenging
+      logical rdstorm ! rocket dust storm parametrization
       logical sedimentation
       logical activice,tifeedback,supersat,caps
Index: trunk/LMDZ.MARS/libf/phymars/callradite_mod.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/callradite_mod.F	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/callradite_mod.F	(revision 1974)
@@ -7,7 +7,9 @@
       SUBROUTINE callradite(icount,ngrid,nlayer,nq,zday,ls,pq,albedo,
      $     emis,mu0,pplev,pplay,pt,tsurf,fract,dist_sol,igout,
-     $     dtlw,dtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,fluxtop_sw,
-     &     tauref,tau,aerosol,dsodust,tauscaling,taucloudtes,rdust,rice,
-     &     nuice,co2ice,clearsky,totcloudfrac)
+     $     dtlw,dtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,
+     $     fluxtop_sw,tauref,tau,aerosol,dsodust,tauscaling,
+     $     taucloudtes,rdust,rice,nuice,co2ice,rstormdust,
+     $     totstormfract,clearatm,dsords,
+     $     clearsky,totcloudfrac)
 
       use aeropacity_mod, only: aeropacity
@@ -16,5 +18,6 @@
       use dimradmars_mod, only: naerkind, name_iaer,
      &            iaer_dust_conrath,iaer_dust_doubleq,
-     &            iaer_dust_submicron,iaer_h2o_ice
+     &            iaer_dust_submicron,iaer_h2o_ice,
+     &            iaer_stormdust_doubleq 
       use yomlw_h, only: gcp, nlaylte
       use comcstfi_h, only: g,cpp
@@ -154,5 +157,4 @@
 c                         the "naerkind" kind of aerosol optical
 c                         properties.
-
 c=======================================================================
 c
@@ -160,5 +162,5 @@
 c    -------------
 c
-#include "callkeys.h"
+      include "callkeys.h"
 
 c-----------------------------------------------------------------------
@@ -170,5 +172,5 @@
 
       REAL,INTENT(IN) :: pq(ngrid,nlayer,nq)
-      REAL,INTENT(IN) :: tauscaling(ngrid) ! Conversion factor for 
+      REAL,INTENT(INOUT) :: tauscaling(ngrid) ! Conversion factor for 
                                ! qdust and Ndust
       REAL,INTENT(IN) :: albedo(ngrid,2),emis(ngrid)
@@ -194,7 +196,14 @@
       REAL,INTENT(OUT) :: nuice(ngrid,nlayer)  ! Estimated effective variance
       REAL,INTENT(IN) :: co2ice(ngrid)           ! co2 ice surface layer (kg.m-2)
+
+c     rocket dust storm
+      LOGICAL,INTENT(IN) :: clearatm ! true for background dust
+      REAL,INTENT(IN) :: totstormfract(ngrid) ! dust storm mesh fraction
+      REAL,INTENT(OUT) :: rstormdust(ngrid,nlayer)  ! Storm dust geometric mean radius (m)
+      REAL dsords(ngrid,nlayer) ! density scaled opacity for rocket dust storm dust
+
 c     sub-grid scale water ice clouds
-      real,intent(out) :: totcloudfrac(ngrid)
-      logical,intent(in) :: clearsky
+      LOGICAL,INTENT(IN) :: clearsky
+      REAL,INTENT(IN) :: totcloudfrac(ngrid)
 
 c
@@ -292,4 +301,5 @@
          iaer_dust_submicron=0
          iaer_h2o_ice=0
+         iaer_stormdust_doubleq=0
 
          aer_count=0
@@ -326,4 +336,12 @@
            enddo
          endif
+         if (rdstorm.AND.active) then
+           do iaer=1,naerkind
+             if (name_iaer(iaer).eq."stormdust_doubleq") then
+               iaer_stormdust_doubleq = iaer
+               aer_count = aer_count + 1
+             endif
+           enddo
+         end if
 
 c        Check that we identified all tracers:
@@ -372,5 +390,5 @@
 c     Updating aerosol size distributions:
       CALL updatereffrad(ngrid,nlayer,
-     &                rdust,rice,nuice,
+     &                rdust,rstormdust,rice,nuice,
      &                reffrad,nueffrad,
      &                pq,tauscaling,tau,pplay)
@@ -385,7 +403,8 @@
 c     Computing aerosol optical depth in each layer:
       CALL aeropacity(ngrid,nlayer,nq,zday,pplay,pplev,ls,
-     &     pq,tauscaling,tauref,tau,taucloudtes,aerosol,dsodust,reffrad,
-     &     nueffrad,QREFvis3d,QREFir3d,omegaREFvis3d,omegaREFir3d,
-     &     clearsky,totcloudfrac)
+     &    pq,tauscaling,tauref,tau,taucloudtes,aerosol,dsodust,reffrad,
+     &    QREFvis3d,QREFir3d,omegaREFir3d,
+     &    totstormfract,clearatm,dsords,
+     &    clearsky,totcloudfrac)
 
 c     Starting loop on sub-domain
Index: trunk/LMDZ.MARS/libf/phymars/callsedim_mod.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/callsedim_mod.F	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/callsedim_mod.F	(revision 1974)
@@ -4,11 +4,11 @@
 
       CONTAINS
-      
-      SUBROUTINE callsedim(ngrid,nlay, ptimestep,
-     &                pplev,zlev, zlay, pt, pdt, rdust, rice,
+
+      SUBROUTINE callsedim(ngrid,nlay,ptimestep,
+     &                pplev,zlev,zlay,pt,pdt,rdust,rstormdust,rice,
      &                rsedcloud,rhocloud,
-     &                pq, pdqfi, pdqsed,pdqs_sed,nq, 
+     &                pq,pdqfi,pdqsed,pdqs_sed,nq, 
      &                tau,tauscaling)
-! to use  'getin'
+
       USE ioipsl_getincom, only: getin
       USE updaterad, only: updaterdust,updaterice_micro,updaterice_typ
@@ -17,6 +17,7 @@
      &                      igcm_ccn_mass, igcm_ccn_number,
      &                      igcm_h2o_ice, nuice_sed, nuice_ref,
-     &                      igcm_ccnco2_mass, igcm_ccnco2_number,
-     &                      igcm_co2_ice
+     &                      igcm_ccnco2_mass,igcm_ccnco2_number,
+     &                      igcm_co2_ice, igcm_stormdust_mass, 
+     &                      igcm_stormdust_number
       USE newsedim_mod, ONLY: newsedim
       USE comcstfi_h, ONLY: g
@@ -61,4 +62,5 @@
 c    Aerosol radius provided by the water ice microphysical scheme:
       real,intent(out) :: rdust(ngrid,nlay) ! Dust geometric mean radius (m)
+      real,intent(out) :: rstormdust(ngrid,nlay) ! Stormdust geometric mean radius (m) 
       real,intent(out) :: rice(ngrid,nlay)  ! H2O Ice geometric mean radius (m)
 c     Sedimentation radius of water ice
@@ -89,8 +91,7 @@
       real r0dust(ngrid,nlay) ! geometric mean radius used for
                                     !   dust (m)
-!      real r0ccn(ngrid,nlay)  ! geometric mean radius used for
+      real r0stormdust(ngrid,nlay) ! Geometric mean radius used for stormdust (m)
 !                                    !   CCNs (m)
       real,save :: beta ! correction for the shape of the ice particles (cf. newsedim)
-
 c     for ice radius computation
       REAL Mo,No
@@ -133,4 +134,8 @@
       INTEGER,SAVE :: iccn_number ! index of tracer containing CCN number
                                   !   mix. ratio
+      INTEGER,SAVE :: istormdust_mass  !  index of tracer containing
+                                       !stormdust mass mix. ratio
+      INTEGER,SAVE :: istormdust_number !  index of tracer containing
+                                        !stormdust number mix. ratio                      
       INTEGER,SAVE :: iccnco2_number ! index of tracer containing CCN number
       INTEGER,SAVE :: iccnco2_mass ! index of tracer containing CCN number
@@ -140,7 +145,8 @@
       LOGICAL,SAVE :: firstcall=.true.
 
+
+
 c    ** un petit test de coherence
 c       --------------------------
-
       ! AS: firstcall OK absolute
       IF (firstcall) THEN
@@ -240,6 +246,5 @@
        ENDIF                    !of if (co2clouds)
 
-
-        IF (water) THEN
+       IF (water) THEN
          write(*,*) "correction for the shape of the ice particles ?"
          beta=0.75 ! default value
@@ -251,5 +256,30 @@
             write(*,*) "water_param nueff Radiative:", nuice_ref
           ENDIF
-        ENDIF
+       ENDIF
+
+       IF (rdstorm) THEN ! identifying stormdust tracers for sedimentation
+           istormdust_mass=0      ! dummy initialization
+           istormdust_number=0    ! dummy initialization
+
+           do iq=1,nq
+             if (noms(iq).eq."stormdust_mass") then
+               istormdust_mass=iq
+               write(*,*)"callsedim: istormdust_mass=",istormdust_mass
+             endif
+             if (noms(iq).eq."stormdust_number") then
+               istormdust_number=iq
+               write(*,*)"callsedim: istormdust_number=",
+     &                                           istormdust_number
+             endif
+           enddo
+
+           ! check that we did find the tracers
+           if ((istormdust_mass.eq.0).or.(istormdust_number.eq.0)) then
+             write(*,*) 'callsedim: error! could not identify'
+             write(*,*) ' tracers for stormdust mass and number mixing'
+             write(*,*) ' ratio and rdstorm is activated!'
+             stop
+           endif
+       ENDIF !of if (rdstorm)
       
         firstcall=.false.
@@ -268,5 +298,4 @@
       zt(1:ngrid,1:nlay)=pt(1:ngrid,1:nlay)
      &                         +pdt(1:ngrid,1:nlay)*ptimestep
-
 
 c    Computing the different layer properties
@@ -295,6 +324,16 @@
         end do
       endif
-
-
+      ! rocket dust storm
+      if (rdstorm) then
+        do l=1,nlay
+          do ig=1, ngrid
+     
+         call updaterdust(zqi(ig,l,igcm_stormdust_mass),
+     &               zqi(ig,l,igcm_stormdust_number),r0stormdust(ig,l),
+     &               tauscaling(ig))
+          
+          end do
+        end do
+      endif
 c =================================================================
       do iq=1,nq
@@ -307,11 +346,11 @@
 c -----------------------------------------------------------------
           if ((doubleq.and.
-     &        ((iq.eq.idust_mass).or.
-     &         (iq.eq.idust_number)))) then
+     &     ((iq.eq.idust_mass).or.(iq.eq.idust_number).or.
+     &     (iq.eq.istormdust_mass).or.(iq.eq.istormdust_number)))) then
      
 c           Computing size distribution:
 c           ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-c            if ((iq.eq.idust_mass).or.(iq.eq.idust_number)) then
+            if ((iq.eq.idust_mass).or.(iq.eq.idust_number)) then
               do  l=1,nlay
                 do ig=1, ngrid
@@ -319,9 +358,17 @@
                 end do
               end do
-              sigma0 = varian
+            else if ((iq.eq.istormdust_mass).or.
+     &                                (iq.eq.istormdust_number)) then
+              do  l=1,nlay
+                do ig=1, ngrid
+                  r0(ig,l)=r0stormdust(ig,l)
+                end do
+              end do
+            endif
+            sigma0 = varian
 
 c        Computing mass mixing ratio for each particle size
 c        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-          IF ((iq.EQ.idust_mass).or.(iq.EQ.iccn_mass)) then
+          IF ((iq.EQ.idust_mass).or.(iq.EQ.istormdust_mass)) then
             radpower = 2
           ELSE  ! number
@@ -376,5 +423,4 @@
 
           do ir=1,nr
-          
                call newsedim(ngrid,nlay,1,1,ptimestep,
      &         pplev,masse,epaisseur,zt,rd(ir),(/rho_dust/),qr(1,1,ir),
@@ -391,5 +437,5 @@
                  zqi(ig,l,iq)=zqi(ig,l,iq)+qr(ig,l,ir)
                ENDDO
-             ENDDO
+             ENDDO            
           enddo ! of do ir=1,nr
 c -----------------------------------------------------------------
@@ -457,5 +503,15 @@
        ENDDO
       endif ! of if (doubleq)
-      
+
+      if (rdstorm) then
+       DO l = 1, nlay
+        DO ig=1,ngrid
+         call updaterdust(zqi(ig,l,igcm_stormdust_mass),
+     &                zqi(ig,l,igcm_stormdust_number),rstormdust(ig,l),
+     &                tauscaling(ig))    
+        ENDDO
+       ENDDO
+      endif ! of if (rdstorm)
+ 
 c     Update the ice particle size "rice"
 c     -------------------------------------
@@ -490,2 +546,3 @@
       
       END MODULE callsedim_mod
+
Index: trunk/LMDZ.MARS/libf/phymars/compute_dtau_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/compute_dtau_mod.F90	(revision 1974)
+++ trunk/LMDZ.MARS/libf/phymars/compute_dtau_mod.F90	(revision 1974)
@@ -0,0 +1,83 @@
+	MODULE compute_dtau_mod
+
+	IMPLICIT NONE
+
+	REAL,PARAMETER :: ti_injection=10/24. ! time of beginning injection
+	REAL,PARAMETER :: tf_injection=18/24. ! time of end injection
+        REAL,PARAMETER :: t_scenario=14/24.   ! time of tauref_scenario
+
+	CONTAINS
+
+	SUBROUTINE compute_dtau(ngrid,nlayer,            		&
+       & 			zday,pplev,tauref,			&
+       & 			ptimestep,dustliftday,local_time)
+
+	USE geometry_mod, only: longitude_deg
+        USE time_phylmdz_mod, only: dtphys, daysec
+        USE comcstfi_h, only: g
+        USE tracer_mod, only: alpha_lift,igcm_dust_mass,igcm_dust_number
+	
+	IMPLICIT NONE
+        
+        include "callkeys.h"
+	
+        INTEGER, INTENT(in) :: ngrid
+	INTEGER, INTENT(in) :: nlayer
+        REAL, INTENT(in) :: zday ! date at lon=0, in fraction of sols
+	REAL, INTENT(in) :: pplev(ngrid,nlayer+1) ! pressure (Pa)
+	REAL, INTENT(in) :: tauref(ngrid) ! Computed dust opacity at 610Pa
+	REAL, INTENT(in) :: ptimestep 
+        REAL, INTENT(in) :: local_time(ngrid)
+        REAL, INTENT(out) :: dustliftday(ngrid) ! Dust injection rate (s-1)
+        
+        INTEGER :: ig, l
+	INTEGER, SAVE :: nb_daystep ! nomber of step a day
+        REAL :: tauref_scenario(ngrid) ! from dust scenario
+        REAL :: zday_scenario
+        REAL,ALLOCATABLE,SAVE :: local_time_prev(:)
+        REAL,ALLOCATABLE,SAVE :: dtau(:) ! Dust opacity increment (at 610Pa)
+        REAL,PARAMETER :: odpref=610. !DOD reference pressure (Pa)
+        
+        LOGICAL, SAVE :: firstcall=.TRUE. ! signals first call to physics
+        
+        
+        IF(firstcall)THEN
+                ALLOCATE(local_time_prev(ngrid))
+                ALLOCATE(dtau(ngrid))
+                DO ig=1,ngrid
+                   local_time_prev(ig)=modulo(1.+(zday-ptimestep/daysec)&
+                                      -INT(zday-ptimestep/daysec) 	&
+                                      +(longitude_deg(ig)/15)/24,1.)
+                   dtau(ig)=0.
+                ENDDO
+                nb_daystep=(daysec/dtphys)
+                firstcall=.FALSE.
+        ENDIF
+        
+	! 1. Obtain tauref_scenario from dust scenario
+	zday_scenario=zday-modulo(zday,1.)
+        call read_dust_scenario(ngrid,nlayer,zday_scenario,pplev,	&
+       & 			tauref_scenario)
+
+	! 2. Compute dtau
+	DO ig=1,ngrid
+         IF ((local_time(ig).ge.t_scenario).and. 			&
+       &          (local_time_prev(ig).lt.(t_scenario)))THEN
+	         dtau(ig)=tauref_scenario(ig)-tauref(ig)
+         ENDIF
+         IF (dtau(ig).LT.0) THEN
+                  dtau(ig)=0.
+         ENDIF
+         
+        ! 3. Use dtau to compute dustliftday
+         dustliftday(ig)=coeff_injection*				&
+       &		(dtau(ig)*pplev(ig,1)/odpref)			&
+       &		/(daysec*(tf_injection-ti_injection))
+        ENDDO 
+         
+        ! 4. Save local time 
+        local_time_prev(1:ngrid)=local_time(1:ngrid)
+        
+        end subroutine compute_dtau
+
+	end module compute_dtau_mod
Index: trunk/LMDZ.MARS/libf/phymars/comsaison_h.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/comsaison_h.F90	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/comsaison_h.F90	(revision 1974)
@@ -9,4 +9,5 @@
   real,save,allocatable :: mu0(:)
   real,save,allocatable :: fract(:)
+  real,save,allocatable :: local_time(:) ! local solar time as fraction of day (0,1)
 
 contains
@@ -19,4 +20,5 @@
     allocate(mu0(ngrid))
     allocate(fract(ngrid))
+    allocate(local_time(ngrid))
   
   end subroutine ini_comsaison_h
@@ -29,4 +31,5 @@
     if (allocated(mu0)) deallocate(mu0)
     if (allocated(fract)) deallocate(fract)
+    if (allocated(local_time)) deallocate(local_time)
 
   end subroutine end_comsaison_h
Index: trunk/LMDZ.MARS/libf/phymars/conf_phys.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/conf_phys.F	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/conf_phys.F	(revision 1974)
@@ -280,4 +280,10 @@
          write(*,*)" calllott = ",calllott
 
+! rocket dust storm injection scheme
+         write(*,*)"call rocket dust storm and slope lifting", 
+     &              " parametrization"
+         rdstorm=.false. ! default value
+         call getin("rdstorm",rdstorm)
+         write(*,*)" rdstorm = ",rdstorm
 
          write(*,*)"rad.transfer is computed every iradia",
@@ -359,4 +365,13 @@
          endif
 
+! dust injection scheme
+        dustinjection=0 ! default: no injection scheme
+        call getin("dustinjection",dustinjection)
+        write(*,*)" dustinjection = ",dustinjection
+! dust injection scheme coefficient        
+        coeff_injection=1. ! default value
+        call getin("coeff_injection",coeff_injection)
+        write(*,*)" coeff_in,jection = ",coeff_injection
+
 ! free evolving dust
 ! freedust=true just says that there is no lifting and no dust opacity scaling.
@@ -372,11 +387,46 @@
          ! this test is valid in GCM case
          ! ... not in mesoscale case, for we want to activate mesoscale lifting
-         if (freedust.and.lifting) then
-           print*,'if freedust is used, then lifting should not be used'
-           print*,'lifting forced to false !!'
-           lifting=.false.
+         if (freedust.and.dustinjection.eq.0)then
+           if(lifting) then
+             print*,'if freedust is used and dustinjection = 0, 
+     &      then lifting should not be used'
+             stop
+           endif
          endif
 #endif
-
+         if (dustinjection.eq.1)then
+           if(.not.lifting) then
+             print*,"if dustinjection=1, then lifting should be true"
+             stop
+           endif
+           if(.not.freedust) then
+             print*,"if dustinjection=1, then freedust should be true"
+             stop
+           endif
+         endif
+! rocket dust storm
+! Test of incompatibility:
+! if rdstorm is used, then doubleq should be true
+         if (rdstorm.and..not.doubleq) then
+           print*,'if rdstorm is used, then doubleq should be used !'
+           stop
+         endif
+         if (rdstorm.and..not.active) then
+           print*,'if rdstorm is used, then active should be used !'
+           stop
+         endif
+         if (rdstorm.and..not.lifting) then
+           print*,'if rdstorm is used, then lifting should be used !'
+           stop
+         endif
+         if (rdstorm.and..not.freedust) then
+           print*,'if rdstorm is used, then freedust should be used !'
+           stop
+         endif
+         if (rdstorm.and.(dustinjection.eq.0)) then
+           print*,'if rdstorm is used, then dustinjection should 
+     &             be used !'
+           stop
+         endif
 ! Dust IR opacity
          write(*,*)" Wavelength for infrared opacity of dust ?"
@@ -642,9 +692,4 @@
            WRITE(*,*) 'equal to 2.'
            CALL ABORT
-         ELSE IF ( (.NOT.activice).AND.(naerkind.GT.1) ) THEN
-           WRITE(*,*) 'naerkind is greater than unity, but'
-           WRITE(*,*) 'activice has not been set to .true.'
-           WRITE(*,*) 'in callphys.def; this is not logical!'
-           CALL ABORT
          ENDIF
 
@@ -666,7 +711,12 @@
           ! and picky compilers who know name_iaer(2) is out of bounds
           j=2
+         IF (rdstorm.AND..NOT.activice) name_iaer(2) = 
+     &                       "stormdust_doubleq" !! storm dust two-moment scheme
+         IF (rdstorm.AND.water.AND.activice) name_iaer(3) = 
+     &                                             "stormdust_doubleq" 
          IF (water.AND.activice) name_iaer(j) = "h2o_ice"      !! radiatively-active clouds
          IF (submicron.AND.active) name_iaer(j) = "dust_submicron" !! JBM experimental stuff
          endif ! of if (nq.gt.1)
+
 c        ----------------------------------------------------------
 
Index: trunk/LMDZ.MARS/libf/phymars/dimradmars_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dimradmars_mod.F90	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/dimradmars_mod.F90	(revision 1974)
@@ -32,4 +32,7 @@
                               ! submicron population of dust
                               ! particles
+  integer iaer_stormdust_doubleq ! Storm dust profile is given by the
+                              ! mass mixing ratio of the two moment scheme 
+                              ! method (doubleq)
   integer iaer_h2o_ice ! Water ice particles
 
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/testphys1d.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/testphys1d.F	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/testphys1d.F	(revision 1974)
@@ -11,5 +11,5 @@
      &                     albedice, iceradius, dtemisice, z0,
      &                     zmea, zstd, zsig, zgam, zthe, phisfi,
-     &                     watercaptag
+     &                     watercaptag, hmons
       use slope_mod, only: theta_sl, psi_sl
       use phyredem, only: physdem0,physdem1
@@ -557,4 +557,6 @@
       zgam(1)=0.E+0
       zthe(1)=0.E+0
+c  for rocket dust storm scheme      
+      hmons(1)=0.E+0
 
 
@@ -716,5 +718,5 @@
       call physdem0("startfi.nc",longitude,latitude,nsoilmx,ngrid,llm,
      &              nq,dtphys,float(day0),time,cell_area,
-     &              albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe)
+     &              albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe,hmons)
       call physdem1("startfi.nc",nsoilmx,ngrid,llm,nq,
      &              dtphys,time,
Index: trunk/LMDZ.MARS/libf/phymars/initracer.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/initracer.F	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/initracer.F	(revision 1974)
@@ -24,5 +24,5 @@
 
 
-#include "callkeys.h"
+      include "callkeys.h"
 
       integer,intent(in) :: ngrid ! number of atmospheric columns
@@ -32,9 +32,10 @@
       integer iq,ig,count
       real r0_lift , reff_lift, nueff_lift
+      real r0_storm,reff_storm
 c     Ratio of small over large dust particles (used when both 
 c       doubleq and the submicron mode are active); In Montmessin
 c       et al. (2002), a value of 25 has been deduced;
       real, parameter :: popratio = 25.
-      character(len=20) :: txt ! to store some text
+      character(len=30) :: txt ! to store some text
 
 c-----------------------------------------------------------------------
@@ -69,4 +70,6 @@
       igcm_h2o_vap=0
       igcm_h2o_ice=0
+      igcm_stormdust_mass=0
+      igcm_stormdust_number=0
       igcm_co2=0
       igcm_co=0
@@ -147,4 +150,16 @@
         enddo
       endif ! of if (submicron)
+       if (rdstorm) then
+        do iq=1,nq
+          if (noms(iq).eq."stormdust_mass") then
+            igcm_stormdust_mass=iq
+            count=count+1
+          endif
+          if (noms(iq).eq."stormdust_number") then
+            igcm_stormdust_number=iq
+            count=count+1
+          endif
+        enddo
+      endif ! of if (rdstorm)     
       ! 2. find chemistry and water tracers
       do iq=1,nq
@@ -422,4 +437,9 @@
 #else
         alpha_lift(igcm_dust_mass)=1.e-6 !1.e-6 !Lifted mass coeff
+        IF (dustinjection.ge.1) THEN
+        	reff_lift = 3.0e-6 ! Effective radius of lifted dust (m)
+        	alpha_lift(igcm_dust_mass)=(4/3.)*reff_lift*rho_dust
+     &           				/2.4
+     	ENDIF
 #endif
 
@@ -437,4 +457,29 @@
         write(*,*) "initracer: doubleq_param alpha_lift:",
      &    alpha_lift(igcm_dust_mass)
+!c ----------------------------------------------------------------------
+!c rocket dust storm scheme
+!c lifting tracer stormdust using same distribution than
+!c normal dust 
+        if (rdstorm) then
+          reff_storm=3.e-6 ! reff_lift !3.e-6
+          r0_storm=reff_storm/ref_r0
+          rho_q(igcm_stormdust_mass)=rho_dust
+          rho_q(igcm_stormdust_number)=rho_dust
+
+          alpha_devil(igcm_stormdust_mass)=9.e-9   ! dust devil lift mass coeff
+          alpha_lift(igcm_stormdust_mass)=4./3./2.4*reff_storm*rho_dust
+
+          write(*,*) 'alpha_lift(rds):',alpha_lift(igcm_stormdust_mass)
+  
+          alpha_devil(igcm_stormdust_number)=r3n_q*
+     &                      alpha_devil(igcm_stormdust_mass)/r0_storm**3
+          alpha_lift(igcm_stormdust_number)=r3n_q*
+     &                       alpha_lift(igcm_stormdust_mass)/r0_storm**3
+  
+          radius(igcm_stormdust_mass) = reff_storm
+          radius(igcm_stormdust_number) = reff_storm
+        end if !(rdstorm)
+!c ----------------------------------------------------------------------
+      
       else
 
@@ -618,5 +663,21 @@
           endif 
        endif
-       
+ 
+       if (rdstorm) then 
+       ! verify that we indeed have stormdust_mass and stormdust_number tracers 
+         if (igcm_stormdust_mass.eq.0) then
+           write(*,*) "initracer: error !!"
+           write(*,*) "  cannot use rdstorm option without ",
+     &                "a stormdust_mass tracer !"
+           stop
+         endif
+         if (igcm_stormdust_number.eq.0) then
+           write(*,*) "initracer: error !!"
+           write(*,*) "  cannot use rdstorm option without ",
+     &                "a stormdust_number tracer !"
+           stop
+         endif
+       endif
+      
        if (callnlte) then ! NLTE requirements
          if (nltemodel.ge.1) then
